#include <list>
#include <vista/VImage.h>
#include "Shape.h"
#include "Line.h"
#include <math.h>

using namespace std;

class Morpher {
 private:
  list<Shape *> *sourcelines;
  list<Shape *> *targetlines;
  list<Shape *> interlines;
  VImage *sourceim;
  VImage *targetim;
  VImage msource;
  VImage mtarget;
  VImage morphed;
 public:
  Morpher(VImage *sourceim, list<Shape *> *sourcelines, VImage *targetim, list<Shape *> *targetlines) {
    this->sourceim = sourceim;
    this->sourcelines=sourcelines;
    this->targetim = targetim;
    this->targetlines = targetlines;
  }
  
  void interpolate_lines(double t);
  double mapu(double x, double y, list<Shape *>::iterator i);
  double mapv(double x, double y, list<Shape *>::iterator i);
  double backmapx(double x, double y, double u, double v, list<Shape *>::iterator i);
  double backmapy(double x, double y, double u, double v, list<Shape *>::iterator i);
  void singlemorph(double t);
  void multimorph(int nummorphs, char* filename);
  VImage getmorphedsource();
  VImage getmorphedtarget();
  VImage getmorphedimage();
};
